<?php

/*

 * To change this template, choose Tools | Templates

 * and open the template in the editor.

 */

class TaskRepository extends EntityRepository
{
    private $table = 'tasks';

    private $options = array(

        'uuid' => null,

        'parent_task_id' => null,

        'project_id' => null,

        'task_name' => null,

        'description' => null,

        'due_date' => null,

        'responsable' => null,

        'prioritie_id' => null,

        'category_id' => null,

        'customer_id' => null,

        'date_start' => null,

        'date_end' => null,

        'due_time' => null,

        'status' => null,

        'date' => null,

        'attachments' => null,

        'task_id' => null,

    );

    public function setOptions($data)
    {

        foreach ($this->options as $option => $value) {

            if (isset($data[$option])) {

                $this->options[$option] = $data[$option];

            }

        }

    }

    public function getOptions()
    {

        return $this->options;

    }

    public function getUUID()
    {

        $query = "SELECT UUID() as uuid ";
        $result = $this->query($query);

        if ($result->num_rows > 0) {

            return $this->resultToArray($result);

        }
        return null;
    }

    public function save(array $data, $table = null)
    {
       // echo "<pre>";var_dump($data);echo "</pre>";exit;


        $tools = new Tools();

        $data['due_date'] = $tools->setFormatDateToDB($data['due_date']);
        $data['due_time'] = $tools->setFormatTimeToDB($data['due_time']);

        $data['uuid'] = implode($this->getUUID()[0]);
        $data['status'] = '1';

        unset($data['attachments']);
        
        unset($data["date"]);

        unset($data["task_id"]);        

        $rs = parent::save($data, $this->table);

        $idFile = $this->getInsertId();

        if($rs){
            return $idFile;
        }
        return null;

        //$rs = parent::save($data, $this->table);

    }

    public function delete($id, $table = null)
    {

        return parent::delete($id, $this->table);

    }
    public function getFormatDate(){

        $date = substr($this->getDate(), 0, 10);

        $date = strftime('%m/%d/%Y',  strtotime($date));

        return $date;

    }

    public function getDate() {

        return date('d-m-y h:i:s');
 
     }
    public function update($id, $data, $table = null)
    {
        $tools = new Tools();
        if(isset($data['due_date'])){
            
            $data['due_date'] = $tools->setFormatDateToDB($data['due_date']);

        }
        if(isset($data['status'])){

            $data['date_start'] = date('m/d/y h:i:s');

        }
        if(isset($data['date_start'])){
            
            $data['date_start'] = $tools->setFormatDateTimeToDB($data['date_start']);

        }
       
        if(isset($data['due_time'])){
            
            $data['due_time'] = $tools->setFormatTimeToDB($data['due_time']);

        }
        
        //Proceso de insert files and upload file FTP
        if(isset($data['attachments'])){
            $fileRepository = new FileRepository();

            $dataFile = array();

            $dataFile['attachments'] = $data['attachments'];
            $dataFile['task_id'] = $id;
         
          
            
            $resultUpload = $fileRepository->save($dataFile);
            //$attachments = $data['attachments'];
                       
        }
        //echo "<pre>";var_dump($data);echo "</pre>";exit;


        unset($data["date"]);
        unset($data['attachments']);
        unset($data["task_id"]); 
       
        return parent::update($id, $data, $this->table);

    }

    public function getById($id, $table = null, $selectAux = null)
    {

        return parent::getById($id, $this->table, $selectAux);

    }

    public function isUsedInRecord($id, array $buscarEn = null, $andWhere = null)
    {

        return parent::isUsedInRecord($id, array('tasks' => 'prioritie_id'));

    }

    public function getListSelectPriorities($idsPriorities = null)
    {

        if ($idsPriorities !== null) {
            $idsPriorities = " AND find_in_set(id,'$idsPriorities')";
        }

        $query = "SELECT * FROM $this->table WHERE 1 = 1 $idsPriorities ORDER BY name ASC";

        $result = $this->query($query);


        if ($result->num_rows > 0) {

            $array = array();

            while ($row = $result->fetch_object()) {

                $array[$row->id] = $row->name;

            }

            return $array;

        }

        return null;

    }

    public function getListPriorities()
    {

        $query = "SELECT * FROM $this->table ORDER BY name ASC";

        $result = $this->query($query);

        if ($result->num_rows > 0) {

            return $this->resultToArray($result);

        }

        return null;

    }

    public function getListStatus()
    {

        $query = "SELECT * FROM status_code WHERE operation = 'Task'";

        $result = $this->query($query);

        if ($result->num_rows > 0) {

            $array = array();

            foreach ($result as $status) {

                $array[$status['code']] = $status['description'];

            }

            return $array;

        }

        return null;

    }

    public function getTaskByProject($project_id, $idUser, $rol,$parent_task_id)
    {
        

        $filterUser = "";
        $filterTask = "";

        if ($rol !== "1") {
            $filterUser = " AND find_in_set(responsable,'$idUser')";
        }
        if($parent_task_id !== ""){
            $filterTask = " AND find_in_set(parent_task_id,'$parent_task_id')";

        }else{
            $filterTask = " AND parent_task_id = 0";

        }

        //responsable like '%$idUser%'

        $query = "SELECT *,t.id as task_id,  date_format(due_date,'%M %d, %Y')as format_due_date, fxGetUserName(responsable) as userName,fxGetInitialName(responsable) as initialName,fxGetColorNameUser(responsable) as colorNameUser,fxGetStatusName(status,'Project')as status_name, CURDATE() as actualDate "
            . ",p.name prioritie_name,p.color "
            . "FROM $this->table t JOIN priorities p on t.prioritie_id = p.id where project_id = '$project_id' $filterTask  $filterUser order by due_date asc";

         // var_dump($query);exit;
        $result = $this->query($query);

        if ($result->num_rows > 0) {

            return $this->resultToArray($result);

        }else{ //UG no encuentra tareas hijas asi que va por el total de tareas por proyecto
            $query = "SELECT *,t.id as task_id,  date_format(due_date,'%M %d, %Y')as format_due_date, fxGetUserName(responsable) as userName,fxGetInitialName(responsable) as initialName,fxGetColorNameUser(responsable) as colorNameUser,fxGetStatusName(status,'Project')as status_name, CURDATE() as actualDate "
            . ",p.name prioritie_name,p.color "
            . "FROM $this->table t JOIN priorities p on t.prioritie_id = p.id where project_id = '$project_id' $filterUser order by due_date asc";
            
          //  var_dump($query);exit;
            $result = $this->query($query);

            if ($result->num_rows > 0) {

                return $this->resultToArray($result);
    
            }
        }

        return null;

    }

    public function getTaskById($id)
    {
        //responsable like '%$idUser%'

        $query = "SELECT *,t.id as task_id,  date_format(due_date,'%M %d, %Y')as format_due_date, fxGetUserName(responsable) as userName, CURDATE() as actualDate "
            . ",p.name prioritie_name,p.color, "
            . "fxGetStatusName(status,'Task')as status_name, "
            . "(select count(t_.id) from tasks t_ where t_.parent_task_id = t.id) as parent "
            . "FROM $this->table t LEFT JOIN priorities p on t.prioritie_id = p.id where t.id = '$id' order by due_date asc";

        //var_dump($query);exit;
        $result = $this->query($query);

        if ($result->num_rows > 0) {

            return $this->resultToArray($result);

        }

        return null;

    }

}